<?php
define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = 'English';
}
include('../languages/' . $user_lang . '.php');

if (!empty($_GET['invtnum']) && is_numeric($_GET['invtnum'])) {
    $invtnum = $_GET['invtnum'];
    include("../config/config_invt$invtnum.php");
    $strt    = $invtnum;
    $upto    = $invtnum;
    $INVNAME = ${'INVNAME' . $invtnum};
} else {
    $strt = 1;
    if ($NUMINV > 1) {
        $INVNAME = "$lgALL";
        $upto    = $NUMINV;
    } else {
        $INVNAME = $INVNAME1;
        $upto    = 1;
    }
}

$topseries[0]['id']   = 'toplevel';
$topseries[0]['name'] = "$lgINVT $INVNAME";

$yearlist = array();
for ($invtnum = $strt; $invtnum <= $upto; $invtnum++) {
    include("../config/config_invt$invtnum.php");
    $dir      = '../data/invt' . $invtnum . '/production/';
    $yearlist = glob($dir . "energy*.csv");
}
sort($yearlist);
$yearscnt      = count($yearlist);
$conso_day     = array();
$drilldowndays = array();

$ncnt = 0;
for ($i = 0; $i < $yearscnt; $i++) {
    for ($invtnum = $strt; $invtnum <= $upto; $invtnum++) {
        $year = substr($yearlist[$i], -8, 4);
        $dir  = '../data/invt' . $invtnum . '/production/';
        
        if (file_exists($dir . 'energy' . $year . '.csv')) {
            $thefile    = file($dir . 'energy' . $year . '.csv');
            $contalines = count($thefile);
            $year       = (int) $year;
            
            for ($line_num = 0; $line_num < $contalines; $line_num++) {
                $array = preg_split("/,/", $thefile[$line_num]);
                $month = substr($array[0], 4, 2);
                $day   = substr($array[0], 6, 2);
                $month = (int) ($month);
                $m     = $month - 1;
                $day   = (int) ($day);
                $d     = $day - 1;
                if (!isset($conso_day[$year][$m][$d])) {
                    $conso_day[$year][$m][$d] = round(($array[1] * ${'CORRECTFACTOR' . $invtnum}), 1);
                } else {
                    $conso_day[$year][$m][$d] += round(($array[1] * ${'CORRECTFACTOR' . $invtnum}), 1);
                }
                $drilldowndays[$year][$m][$d] = array(
                    'name' => "$day",
                    'y' => $conso_day[$year][$m][$d]
                );
            } // end of looping through the file	
        }
        
        if ($year == date('Y')) { // Add today conso
            $dir    = '../data/invt' . $invtnum . '/csv/';
            $output = glob($dir . '*.csv');
            rsort($output);
            if (isset($output[0])) {
                $file       = file($output[0]);
                $month      = substr($output[0], -8, 2);
                $day        = substr($output[0], -6, 2);
                $contalines = count($file);
                $prevarray  = preg_split('/,/', $file[1]);
                $linearray  = preg_split('/,/', $file[$contalines - 1]);
                $val_first  = $prevarray[1];
                $val_last   = $linearray[1];
                settype($val_first, 'float');
                settype($val_last, 'float');
                
                if ($val_first <= $val_last) {
                    $val_last -= $val_first;
                } else { // counter pass over
                    $val_last += ${'PASSO' . $invtnum} - $val_first;
                }
                
                $month = (int) ($month);
                $m     = $month - 1;
                $day   = (int) ($day);
                $d     = $day - 1;
                if (!isset($conso_day[$year][$m][$d])) {
                    $conso_day[$year][$m][$d] = round((($linearray[27] - $prevarray[27]) * ${'CORRECTFACTOR' . $invtnum}), 1);
                } else {
                    $conso_day[$year][$m][$d] += round((($linearray[27] - $prevarray[27]) * ${'CORRECTFACTOR' . $invtnum}), 1);
                }
                $drilldowndays[$year][$m][$d] = array(
                    'name' => "$day",
                    'y' => $conso_day[$year][$m][$d]
                );
            }
        } // end of today conso
    } // each invt 
    
    $conso_y = 0;
    $stmonth = 1;
    for ($h = 0; $h < 12; $h++) { // Fill blanks dates
        $daythatm = cal_days_in_month(CAL_GREGORIAN, $stmonth, $year);
        for ($j = 0; $j < $daythatm; $j++)
            if (!isset($conso_day[$year][$h][$j])) {
                $conso_day[$year][$h][$j]     = 0;
                $d                            = $j + 1;
                $h                            = (int) $h;
                $j                            = (int) $j;
                $drilldowndays[$year][$h][$j] = array(
                    'name' => "$d",
                    'y' => 0
                );
            }
        $stmonth++;
        $conso_y += array_sum($conso_day[$year][$h]);
    }
    $conso_y = floatval($conso_y);
    $title   = "$INVNAME $year: ";
    $title .= number_format($conso_y, 1, $DPOINT, $THSEP);
    $title .= " kWh";
    
    $topseries[0]['data'][$i] = array(
        'name' => "$year",
        'y' => $conso_y,
        'drilldown' => 'y' . $year, //y2015
        'title' => $title
    );
    
    $m = 1;
    
    for ($h = 0; $h < 12; $h++) { // each h month
        $conso_m = array_sum($conso_day[$year][$h]);
        $conso_m = floatval($conso_m);
        sort($drilldowndays[$year][$h]); // ici
        $title = "$INVNAME $lgMONTH[$m] $year: ";
        $title .= number_format($conso_m, 1, $DPOINT, $THSEP);
        $title .= ' kWh';
        
        $drilldownmonths[$year][$h] = array(
            'name' => "$lgSMONTH[$m]",
            'y' => $conso_m,
            'drilldown' => 'm' . $year . $m, // m201508
            'title' => $title
        );
        
        if ($h == 0) {
            $return['series'][$ncnt]['id']   = 'y' . $year; //y2015
            $return['series'][$ncnt]['name'] = "$year";
            $thisy                           = $ncnt;
            $ncnt++;
        }
        $return['series'][$ncnt]['id']   = 'm' . $year . $m; //m201508
        $return['series'][$ncnt]['name'] = "$lgSMONTH[$m] $year";
        $return['series'][$ncnt]['data'] = $drilldowndays[$year][$h];
        $m++;
        $ncnt++;
    } // each month
    $return['series'][$thisy]['data'] = $drilldownmonths[$year];
} // each year file

sort($topseries);
$return1[0] = $topseries;

$jsonreturn = array(
    'series' => $return1[0],
    'drilldown' => $return
);

header("Content-type: text/json");
echo json_encode($jsonreturn);
?>
